%CCWIN=1
#Include "win32api.inc"

Function MyProc (ByVal hWnd As Long, ByVal wMsg As Long, _
                 ByVal wParam As Long, ByVal lParam As Long)  As Long

    Dim hDC As Long

    Select Case wMsg
    Case %WM_LBUTTONDOWN

      hDC = GetDC(hWnd)
      TextOut hDC, 20, 20, "Hello World!", 12

    Case Else
      Function = DefWindowProc(hWnd, wMsg, wParam, lParam)
    End Select

End Function

Function MakeWindow () As Long

    Local wce         As WndClassEx
    Local szClassName As Asciiz * 64
    Local hWnd        As Long
    Local hInst       As Long

    Static registered As Long

    hInst = GetModuleHandle(ByVal %NULL)

    If IsFalse registered Then
        szClassName          = "MYWINDOW"
        wce.cbSize           = SizeOf(wce)
        wce.style            = %CS_HREDRAW Or %CS_VREDRAW
        wce.lpfnWndProc      = CodePtr(MyProc)
        wce.cbClsExtra       = 0
        wce.cbWndExtra       = 0
        wce.hInstance        = hInst
        wce.hIcon            = %NULL
        wce.hCursor          = LoadCursor( 0, ByVal %IDC_ARROW)
        wce.hbrBackground    = GetStockObject(%WHITE_BRUSH)
        wce.lpszMenuName     = %NULL
        wce.lpszClassName    = VarPtr(szClassName)
        wce.hIconSm          = %NULL
        RegisterClassEx wce
        registered = %TRUE
    End If

    hWnd = CreateWindow(szClassName, _
                        "MY WINDOW", _
                        %WS_OVERLAPPEDWINDOW, _
                        5, 5, 200, 200, _
                        %NULL, _
                        %NULL, _
                        hInst, _
                        ByVal %NULL)

    If IsFalse hWnd Then
        hWnd = GetLastError
    Else
        ShowWindow hWnd, %SW_SHOW
        UpdateWindow hWnd
    End If

    Function = hWnd

End Function


Function PbMain

  Dim hWnd As Long
  Dim Msg As tagMsg

  hWnd = MakeWindow

  While IsWindow(hWnd) And GetMessage(Msg, %NULL, 0, 0) > 0
    TranslateMessage Msg
    DispatchMessage Msg
  Loop

End Function
